import re
import unicodedata
from cdrlib import xsd

standard = "[#xC0-#xD6] | [#xD8-#xF6] | [#xF8-#x2FF] | [#x370-#x37D] | [#x37F-#x1FFF] | [#x200C-#x200D] | [#x2070-#x218F] | [#x2C00-#x2FEF] | [#x3001-#xD7FF] | [#xF900-#xFDCF] | [#xFDF0-#xFFFD] | [#x10000-#xEFFFF] | [#x0300-#x036F] | [#x203F-#x2040]"
ranges = standard.split(" | ")
def parse_range(range):
    start, end = [int(n.replace("#", "0"), 16) for n in range[1:-1].split("-")]
    return "\\U%08X-\\U%08X" % (start, end)
for range in sorted([parse_range(r) for r in ranges]):
    print("%sr\"%s\"" % (" " * 8, range))
i = 0
while i <= 0xFFFF:
    c = chr(i)
    a, b = xsd.DTD.is_nmtoken(c), xsd.DTD.nmtoken(c)
    if a != b:
        print(hex(i), a, b, unicodedata.category(c))
    i += 1

