import cgi
import difflib
import glob
import os
import re
import sys

TABLES = False

def fix_attlist(line):
    words = line.strip()[:-1].split()
    element = words[1]
    words = words[2:]
    attributes = []
    while words:
        name, model, use = words[:3]
        if model.startswith("("):
            values = model[1:-1].split("|")
            model = "(%s)" % "|".join(sorted(values))
        model = model.replace("NMTOKEN", "CDATA")
        attributes.append(" ".join([name, model, use]))
        words = words[3:]
    return "<!ATTLIST %s %s>" % (element, " ".join(sorted(attributes)))
def normalize(dtd):
    dtd = str(dtd, "utf-8").replace(".xml -->", ".xsd -->")
    lines = []
    for line in dtd.splitlines():
        if line.startswith("<!ATTLIST"):
            line = fix_attlist(line)
        lines.append(line + "\n")
    return lines

def diff_dtds(old, new):
    old, new = normalize(old), normalize(new)
    if TABLES:
        differ = difflib.HtmlDiff()
        return differ.make_table(old, new, context=True, numlines=1)
    else:
        diffs = []
        for line in difflib.context_diff(old, new):
            if line.strip() and line[0] != " ":
                diffs.append(line)
        return "".join(diffs)
        diffs = [cgi.escape(line) for line in difflib.context_diff(old, new)]
        if not diffs:
            return ""
        return "<pre>" + "".join(diffs) + "</pre>"
        differ = difflib.differ()
        return differ.make_table(old, new, context=True, numlines=1)

docs_with_diffs = 0
html = ["<!DOCTYPE html>\n<html><head><meta charset='utf-8'><body>"]
for path in glob.glob("old-dtds/*.dtd"):
    if "schema.dtd" in path:
        continue
    name = os.path.basename(path)
    old = open(path, "rb").read()
    new = open("new-dtds/%s" % name, "rb").read()
    table = diff_dtds(old, new)
    if table and "No Differences Found" not in table:
        print("%s\n%s" % (name, table.strip()))
        continue
        html.append("<h2>%s</h2>" % name)
        html.append(table)
        docs_with_diffs += 1
        if docs_with_diffs > 10:
            break
#html.append("</body></html>")
#html = bytes("\n".join(html) + "\n", "utf-8")
#sys.stdout.buffer.write(html)
