import lxml.etree as etree

xslt = etree.XML("""\
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:template match="a">
    <xsl:apply-templates select="b">
      <xsl:with-param name="p"><p/></xsl:with-param>
    </xsl:apply-templates>
  </xsl:template>
  <xsl:template match="b">
    <xsl:param name="p"/>
    <xsl:choose>
      <xsl:when test="$p/foo"><foo/></xsl:when>
      <xsl:otherwise><bar/></xsl:otherwise>
    </xsl:choose>
  </xsl:template>
</xsl:stylesheet>
""")
transform = etree.XSLT(xslt)
doc = etree.XML("<a><b/></a>")
result = transform(doc)
print(type(result))
print(result)
