from io import BytesIO
from lxml import etree
from cdrlib import db, xsd, util
import logging

def r(*a, **b):
    print(a)
    print(b)
logging.basicConfig(level="DEBUG")
source = BytesIO(b"<a><b/><b/><c/></a>")
schema = etree.XMLSchema(etree.XML("""\
<xsd:schema xmlns:xsd="http://www.w3.org/2001/XMLSchema">
 <xsd:element name="a" type="a"/>
 <xsd:complexType name="a">
  <xsd:sequence>
   <xsd:element name="b" type="b"/>
   <xsd:element name="c" type="b"/>
  </xsd:sequence>
 </xsd:complexType>
 <xsd:complexType name="b">
  <xsd:sequence>
   <xsd:element name="d" type="xsd:string"/>
  </xsd:sequence>
 </xsd:complexType>
</xsd:schema>
"""))
try:
    parser = etree.iterparse(source, ("start", "end"), schema=schema)
    for event, element in parser:
        print(event, element)
        for e in parser.error_log:
            print("\t%s" % e)
except Exception as e:
    print(e, type(e))
err = parser.error_log[0]
print(err.level_name, err.type, err.type_name, dir(err))
print(err.message)
