import lxml.etree as etree

xslt_tree = etree.XML('''\
<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:param name="a" select="'garbage'"/>
    <xsl:template match="/">
        <foo><xsl:value-of select="$a" /></foo>
    </xsl:template>
</xsl:stylesheet>''')
transform = etree.XSLT(xslt_tree)
sp = etree.XSLT.strparam("2017-03-04")
doc_root = etree.XML('<a><b>Text</b></a>')
print(transform(doc_root))
print(type(transform(doc_root)))
print(transform(doc_root, a="2017-03-04"))
print(transform(doc_root, a="'2017-03-04'"))
print(transform(doc_root, a=sp))
print(str(type(sp)))
print(repr(sp))
