import glob
import os
from lxml import etree

NS = "http://www.w3.org/2001/XMLSchema"
combos = set()
for path in glob.glob("../data/schemas/original/*.xml"):
    path = path.replace("\\", "/")
    if "/schema.xml" in path:
        continue
    #print(path)
    root = etree.parse(path).getroot()
    for node in root.iter("{%s}attribute" % NS):
        name = node.get("name")
        type = node.get("type")
        #print(node.tag, name, type)
        if "cdr:" in str(name):
            parent = node.getparent()
            print(os.path.basename(path), parent.tag, parent.get("name"),
                  name, type)
            combos.add((name, type))
for combo in sorted(combos):
    print(combo)
