import glob
import logging
import os
from lxml import etree
from cdrlib import util, xsd

NS = "http://www.w3.org/2001/XMLSchema"

logging.basicConfig(level="DEBUG")
for path in glob.glob("%s/*.xsd" % util.Prototype.SCHEMA_DIR):
    root = etree.parse(path).getroot()
    e = root.find("{%s}element" % NS)
    if e is not None:
        name = os.path.basename(path)
        print(name)
        dtd = str(xsd.DTD(name=name))
        path = "%s/dtds/new/%s.dtd" % (util.Prototype.DATA_DIR, e.get("name"))
        open(path, "wb").write(bytes(dtd, "utf-8"))
