from builtins import str
from lxml import etree

XSL = "http://www.w3.org/1999/XSL/Transform"
CDR = "cips.nci.nih.gov/cdr"
NSMAP = { "xsl": XSL, "cdr": CDR }
TOP_ARGS = { "version": "1.0", "nsmap": NSMAP }
TRANSFORM = "{%s}transform" % XSL
TEMPLATE = "{%s}template" % XSL
PARAM = "{%s}param" % XSL
APPLY = "{%s}apply-templates" % XSL
ELEM = "{%s}element" % XSL
ATTR = "{%s}attribute" % XSL
IF = "{%s}if" % XSL
VALUE = "{%s}value-of" % XSL
CALL = "{%s}call-template" % XSL
WITH = "{%s}with-param" % XSL
VAR = "{%s}variable" % XSL
CHOOSE = "{%s}choose" % XSL
WHEN = "{%s}when" % XSL
ELSE = "{%s}otherwise" % XSL
PARENT = "$node-part/parent::node()"
POSITION = "count($node-part/preceding-sibling::*)+1"

root = etree.Element(TRANSFORM, **TOP_ARGS)
template = etree.SubElement(root, TEMPLATE, match="/")
error = etree.SubElement(template, "Errors")
etree.SubElement(error, APPLY)
template = etree.SubElement(root, TEMPLATE, match="node()")
etree.SubElement(template, APPLY)
template = etree.SubElement(root, TEMPLATE, name="pack-error")
etree.SubElement(template, PARAM, name="msg")
err = etree.SubElement(template, ELEM, name="Err")
test = etree.SubElement(err, IF, test="./@cdr-eid")
attr = etree.SubElement(test, ATTR, name="cdr-eid")
etree.SubElement(attr, VALUE, select="./@cdr-eid")
call = etree.SubElement(err, CALL, name="get-path")
etree.SubElement(call, WITH, name="node-part", select=".")
etree.SubElement(err, VALUE, select='concat(":", $msg)')
template = etree.SubElement(root, TEMPLATE, name="get-path")
etree.SubElement(template, PARAM, name="child-part")
etree.SubElement(template, PARAM, name="node-part")
etree.SubElement(template, VAR, name="parent", select=PARENT)
etree.SubElement(template, VAR, name="my-name", select="name($node-part)")
choose = etree.SubElement(template, CHOOSE)
when = etree.SubElement(choose, WHEN, test="name($parent)")
etree.SubElement(when, VAR, name="my-pos", select=POSITION)
call = etree.SubElement(when, CALL, name="get-path")
select = 'concat("/", $my-name, "[", $my-pos, "]", $child-part)'
etree.SubElement(call, WITH, name="child-part", select=select)
etree.SubElement(call, WITH, name="node-part", select="$parent")
otherwise = etree.SubElement(choose, ELSE)
select = 'concat("/", name($node-part), $child-part)'
etree.SubElement(otherwise, VALUE, select=select)
xsl = etree.tostring(root, pretty_print=True, encoding="utf-8")
print(str(xsl.strip(), "utf-8"))
