import unicodedata

categories = {}
start = i = 0
current = None
while i <= 0xFFFF:
    category = unicodedata.category(chr(i))
    if category != current:
        if current:
            if category not in categories:
                categories[category] = []
            categories[category].append((start, i - 1))
        current = category
        start = i
    i += 1
if start < 0x10000:
    if category not in categories:
        categories[category] = []
    categories[category].append((start, 0xFFFF))
for category in sorted(categories):
    line = ["%s:" % category]
    for start, end in categories[category]:
        line.append("[%04X-%04X]" % (start, end))
    print(" ".join(line))
